using System;
using Assets.Scripts.ModBus;
using Assets.Scripts.Serial;
using UnityEngine;
using UnityEngine.UI;

namespace Assets.Scripts
{
    public class AppStart : MonoBehaviour
    {
        private void Awake()
        {
        }

        private void Start()
        {
            var uiRoot = GameObject.Find("UIRoot").transform;
            var uiCamera = GameObject.Find("UICamera").GetComponent<Camera>();
            var motionControl = uiRoot.Find("MotionControl");

            var mainUi = uiRoot.Find("MainUi");
            var mainGrid = mainUi.Find("MainGrid");
            var grid = mainGrid.Find("Grid");
            var btnOpenSerial = grid.Find("Btn1").GetComponent<Button>();
            btnOpenSerial.onClick.AddListener(OnBtnOpenSerial);
            var btnCloseSerial = grid.Find("Btn2").GetComponent<Button>();
            btnCloseSerial.onClick.AddListener(OnBtnCloseSerialClick);
            var btnSendData = grid.Find("Btn3").GetComponent<Button>();
            btnSendData.onClick.AddListener(OnBtnSendDataClick);

            var grid2 = mainGrid.Find("Grid2");
            var btnHoldingRegister = grid2.Find("Btn1").GetComponent<Button>();
            btnHoldingRegister.onClick.AddListener(OnBtnHoldingRegisterClick);
            var btnInputRegister = grid2.Find("Btn2").GetComponent<Button>();
            btnInputRegister.onClick.AddListener(OnBtnInputRegisterClick);
            var btnMultipleRegister = grid2.Find("Btn3").GetComponent<Button>();
            btnMultipleRegister.onClick.AddListener(OnBtnMultipleRegisterClick);

            var grid3 = mainGrid.Find("Grid3");
            var btnSetRtuSlave = grid3.Find("Btn1").GetComponent<Button>();
            btnSetRtuSlave.onClick.AddListener(OnBtnSetRtuSlaveClick);

            SerialModel.Instance.SetSerialPort();
            ModBusRtu.Instance.Init();
        }

        private void OnBtnOpenSerial()
        {
            try
            {
                SerialModel.Instance.Open();
            }
            catch (Exception e)
            {
                Debug.LogError("޷򿪴˴ڣǷռ");
                throw;
            }
        }

        private void OnBtnCloseSerialClick()
        {
            SerialModel.Instance.Close();
        }

        private void OnBtnSendDataClick()
        {
            SerialModel.Instance.SendData("hello!");
        }

        private void OnBtnHoldingRegisterClick()
        {
            var registers = ModBusRtu.Instance.ModbusSerialRtuMasterReadHoldingRegisters();
            for (int i = 0; i < registers.Length; i++)
            {
                Debug.Log($"index:{i},value:{registers[i]}");
            }
        }

        private void OnBtnInputRegisterClick()
        {
            var registers = ModBusRtu.Instance.ModbusSerialRtuMasterReadInputRegisters();
            for (int i = 0; i < registers.Length; i++)
            {
                Debug.Log($"index:{i},value:{registers[i]}");
            }
        }

        private void OnBtnMultipleRegisterClick()
        {
            ModBusRtu.Instance.ModbusSerialRtuMasterWriteMultipleRegisters();
        }

        private void OnBtnSetRtuSlaveClick()
        {
            ModBusRtu.Instance.StartModbusSerialRtuSlave();
        }

        void OnApplicationQuit()
        {
            ModBusRtu.Instance.Dispose();
        }
    }
}