using System;
using UnityEngine;
using UnityEngine.UI;

namespace Assets.Scripts.ModBus
{
    public static class ModBusHelper
    {
        public static byte[] Crc16(byte[] data)
        {
            var len = data.Length;
            if (len <= 0) return new byte[] { 0, 0 };

            ushort crc = 0xFFFF;
            for (int i = 0; i < len; i++)
            {
                crc = (ushort)(crc ^ (data[i]));
                for (int j = 0; j < 8; j++)
                {
                    crc = (crc & 1) != 0 ? (ushort)((crc >> 1) ^ 0xA001) : (ushort)(crc >> 1);
                }
            }

            byte hi = (byte)((crc & 0xFF00) >> 8); //λ
            byte lo = (byte)(crc & 0x00FF); //λ

            return BitConverter.IsLittleEndian ? new byte[] { lo, hi } : new byte[] { hi, lo };
        }
    }
}