using System.IO.Ports;
using UnityEngine;

namespace Assets.Scripts.Serial
{
    public class SerialModel
    {
        private static SerialModel m_Instance;
        public static SerialModel Instance
        {
            get
            {
                if (m_Instance == null)
                    m_Instance = new SerialModel();
                return m_Instance;
            }
        }

        private SerialPort m_SerialPort;
        
        public void SetSerialPort()
        {
            string[] serialPortArray = SerialPort.GetPortNames();
            foreach (string serialPort in serialPortArray)
            {
                Debug.Log($"Serial Port Name:{serialPort}");
            }

            m_SerialPort = new SerialPort();

            //˿
            m_SerialPort.PortName = "COM2";

            //
            m_SerialPort.BaudRate = 9600;

            //żУ
            m_SerialPort.Parity = Parity.None;

            //λ
            m_SerialPort.DataBits = 8;

            //ֹͣλ
            m_SerialPort.StopBits = StopBits.One;

            //ڽ¼
            m_SerialPort.DataReceived += ReceiveData;
        }

        public void Open()
        {
            m_SerialPort.Open();
        }

        public void Close()
        {
            m_SerialPort.Close();
        }

        public void SendData(byte[] data)
        {
            var isOpen = m_SerialPort.IsOpen;
            if (!isOpen)
            {
                Open();
            }

            //ֽ
            //1Ҫд˿ڵݵֽ顣
            //2д㿪ʼֽƫӴ˴ʼֽڸƵ˿ڡ
            //3Ҫдֽ 
            m_SerialPort.Write(data, 0, data.Length);
        }

        public void SendData(string data)
        {
            var isOpen = m_SerialPort.IsOpen;
            if (!isOpen)
            {
                Open();
            }

            //ֱӷַ
            m_SerialPort.Write(data);
        }

        private void ReceiveData(object obj, SerialDataReceivedEventArgs e)
        {
            //ȡڻֽ
            byte[] result = new byte[m_SerialPort.BytesToRead];
            m_SerialPort.Read(result, 0, m_SerialPort.BytesToRead);
        }
    }
}